不为成仙,只为在这红尘中等你回来。

您现在的位置是:网站首页>>Django

天天生鲜 django.core.exceptions.ImproperlyConfigured: Error loading MySQLdb module.

2019年8月8日 22:36 | 分类:Django | 标签: Python Django

问题描述

Python3 + Django2.2 天天生鲜项目在迁移数据库($ python3 manage.py makemigrations)时出现如下报错:

(venv) fang@ubuntu:~/dailyfresh$ python manage.py makemigrations
Traceback (most recent call last):
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/db/backends/mysql/base.py", line 15, in <module>
    import MySQLdb as Database
ImportError: No module named 'MySQLdb'

The above exception was the direct cause of the following exception:

Traceback (most recent call last):
  File "manage.py", line 15, in <module>
    execute_from_command_line(sys.argv)
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/core/management/__init__.py", line 381, in execute_from_command_line
    utility.execute()
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/core/management/__init__.py", line 357, in execute
    django.setup()
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/__init__.py", line 24, in setup
    apps.populate(settings.INSTALLED_APPS)
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/apps/registry.py", line 114, in populate
    app_config.import_models()
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/apps/config.py", line 211, in import_models
    self.models_module = import_module(models_module_name)
  File "/home/fang/dailyfresh/venv/lib/python3.5/importlib/__init__.py", line 126, in import_module
    return _bootstrap._gcd_import(name[level:], package, level)
  File "<frozen importlib._bootstrap>", line 986, in _gcd_import
  File "<frozen importlib._bootstrap>", line 969, in _find_and_load
  File "<frozen importlib._bootstrap>", line 958, in _find_and_load_unlocked
  File "<frozen importlib._bootstrap>", line 673, in _load_unlocked
  File "<frozen importlib._bootstrap_external>", line 665, in exec_module
  File "<frozen importlib._bootstrap>", line 222, in _call_with_frames_removed
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/contrib/auth/models.py", line 2, in <module>
    from django.contrib.auth.base_user import AbstractBaseUser, BaseUserManager
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/contrib/auth/base_user.py", line 47, in <module>
    class AbstractBaseUser(models.Model):
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/db/models/base.py", line 117, in __new__
    new_class.add_to_class('_meta', Options(meta, app_label))
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/db/models/base.py", line 321, in add_to_class
    value.contribute_to_class(cls, name)
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/db/models/options.py", line 204, in contribute_to_class
    self.db_table = truncate_name(self.db_table, connection.ops.max_name_length())
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/db/__init__.py", line 28, in __getattr__
    return getattr(connections[DEFAULT_DB_ALIAS], item)
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/db/utils.py", line 201, in __getitem__
    backend = load_backend(db['ENGINE'])
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/db/utils.py", line 110, in load_backend
    return import_module('%s.base' % backend_name)
  File "/home/fang/dailyfresh/venv/lib/python3.5/importlib/__init__.py", line 126, in import_module
    return _bootstrap._gcd_import(name[level:], package, level)
  File "/home/fang/dailyfresh/venv/lib/python3.5/site-packages/django/db/backends/mysql/base.py", line 20, in <module>
    ) from err
django.core.exceptions.ImproperlyConfigured: Error loading MySQLdb module.
Did you install mysqlclient?

出错原因

MySQLdb 只支持 Python2.*,还不支持 3.*。

解决方法

可以用 PyMySQL 代替。安装方法:pip install PyMySQL

然后在与 settings 文件同目录的 __init__.py 文件中加入以下代码

import pymysql
pymysql.install_as_MySQLdb()